#!/usr/bin/ruby

require 'socket'
require 'json'

smbstatus=`/usr/bin/smbstatus -p`

output = []

users = {}

smbstatus.each_line do |line|
   if line !~ /-----------/ and line !~ /^PID/ and line !~ /^Samba/ and line != "\n"
     line = line.gsub(/ [ ]*/, ' ')
     line = line.gsub('domain users', '')
     items = line.split(/ /)
     users[items[0]] = { 'user' => items[1], 'pid' => items[0], 'ip' => items[3] }
   end
end

smbstatus=`/usr/bin/smbstatus -S`

date=Time.now.to_i

hostname = Socket.gethostname.gsub(/[0-9]/, '')

smbstatus.each_line do |line|
   if line !~ /------------/ and line !~ /^Service/ and line != "\n"
     line = line.gsub(/ [ ]*/, ' ')
     items = line.split(/ /)
     if users[items[1]] != nil and items[0] != 'IPC$'
        users[items[1]].store('share',items[0])
        output << {'user'     => users[items[1]]['user'],
                   'ip'       => users[items[1]]['ip'],
                   'share'    => items[0],
                   'host'     => hostname,
                   'time'     => date,
                   'name'     => 'smbstats',
                   'user_tag' => users[items[1]]['user'],
                  }
     end
   end
end


puts (JSON.pretty_generate(output))
